summaryrefslogtreecommitdiffstats
path: root/src/oh-applypatches.sh
diff options
context:
space:
mode:
Diffstat (limited to 'src/oh-applypatches.sh')
-rw-r--r--src/oh-applypatches.sh46
1 files changed, 46 insertions, 0 deletions
diff --git a/src/oh-applypatches.sh b/src/oh-applypatches.sh
new file mode 100644
index 0000000..f43dbfb
--- /dev/null
+++ b/src/oh-applypatches.sh
@@ -0,0 +1,46 @@
+#! /bin/sh
+#
+# opkhelper
+# src/oh-applypatches
+# Apply patches to source code.
+#
+# Copyright (C) 2012 Patrick "P. J." McDermott
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+print_usage()
+{
+ printf 'Usage: %s\n' "$1"
+}
+
+if [ ${#} -ne 0 ]; then
+ print_usage ${0} >&2
+ exit 1
+fi
+
+applied=false
+
+if [ -d ../patches ]; then
+ # Iterate over patches ordered alphabetically by name.
+ for patch in $(ls -1 ../patches | sort); do
+ printf 'oh-applypatches: Applying patch "%s"...\n' "${patch}"
+ patch -N -p 1 -u -d src -i "../../patches/${patch}" || exit 1
+ applied=true
+ done
+fi
+
+# Provide output even if patches directory didn't exist or had no visible files.
+if ! ${applied}; then
+ printf 'oh-applypatches: No patches to be applied.\n'
+fi